from dune.perftool.generation import (backend,
                                      domain)
from dune.perftool.pdelab.geometry import world_dimension
from dune.perftool.pdelab.spaces import name_leaf_lfs


def lfs_inames(element, restriction, count=None, context=''):
    assert not ((context == '') and (count is None))
    if count is not None:
        if context != '':
            context = "{}_{}".format(count, context)
        else:
            context = str(count)

    lfs = name_leaf_lfs(element, restriction)

    dim_names = ["x","y","z"] + [str(i) for i in range(4,world_dimension()+1)]
    name = "micro_{}_{}_index_".format(lfs, context)
    inames = tuple()
    for i in range(world_dimension()):
        inames = inames + (name+dim_names[i],)
        domain(name+dim_names[i], element.degree() + 1)
    return inames[-1::-1]
